<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>JavaScript: Objekty</title><meta name="author" content="Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reset.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reveal.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/theme/serif.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right{float:right}

/* listing block */
.reveal .listingblock.stretch>.content{height: 100%}
.reveal .listingblock.stretch>.content>pre{height: 100%}
.reveal .listingblock.stretch>.content>pre>code{height:100%;max-height:100%}

/* tables */
table{border-collapse:collapse;border-spacing:0}
table{margin-bottom:1.25em;border:solid 1px #dedede}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
td.tableblock>.content{margin-bottom:1.25em}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
.reveal table th.halign-left,.reveal table td.halign-left{text-align:left}
.reveal table th.halign-right,.reveal table td.halign-right{text-align:right}
.reveal table th.halign-center,.reveal table td.halign-center{text-align:center}
.reveal table th.valign-top,.reveal table td.valign-top{vertical-align:top}
.reveal table th.valign-bottom,.reveal table td.valign-bottom{vertical-align:bottom}
.reveal table th.valign-middle,.reveal table td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{font-weight:bold}
thead{display:table-header-group}

.reveal table.grid-none th,.reveal table.grid-none td{border-bottom:0!important}

/* kbd macro */
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}

/* callouts */
.conum[data-value] {display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:50%;border-radius:50%;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]:after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
/* Callout list */
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table{border: 0}
/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist>table th, .reveal .colist>table td {border-bottom:0}
/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td{line-height:inherit}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
  padding: .75rem;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}
</style><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/all.min.css"><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/v4-shims.min.css"><!--Printing and PDF exports--><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/pdf.css" : "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>JavaScript</h1><h2>Objekty</h2><div class="preamble"><div class="paragraph"><p><a href="https://eloquentjavascript.net/06_object.html" class="bare">https://eloquentjavascript.net/06_object.html</a></p></div></div><p class="author"><small>Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;</small></p></section>
<section id="_základní_myšlenka"><h2>Základní myšlenka</h2><div class="slide-content"><div class="paragraph"><p>Základní myšlenkou objektů je rozdělení programu na malé části, které jsou zodpovědné za svůj stav</p></div>
<div class="ulist"><ul><li><p>Každý objekt si uchová svoje proměnné</p></li><li><p>Ostatní části kódu s objektem pracují přes metody a vlastnosti</p></li><li><p>Javascript nerozlišuje mezi soukromými a veřejnými vlastnostmi a metodami</p><div class="ulist"><ul><li><p>5eší se například <code>_</code> před jménem</p></li></ul></div></li></ul></div></div></section>
<section><section id="_metody"><h2>Metody</h2><div class="slide-content"><div class="paragraph"><p>Doposud jsem se o metody moc nezajímaly pojďme to napravit.</p></div><div class="ulist"><ul><li><p>Metody jsou vlastně funkce přiřazené objektu</p></li></ul></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let rabbit = {};
rabbit.speak = function(line) {
 console.log(`The rabbit says '${line}'`);
};

rabbit.speak("I'm alive.");
// → The rabbit says 'I'm alive.'</code></pre></div></div></div></section><section id="_klíčové_slovo_this"><h2>klíčové slovo <code>this</code></h2><div class="slide-content"><div class="paragraph"><p>Pokud potřebuje v metodě pracovat s objektem, ke kterému metoda patří, používáme klíčové slovo <code>this</code>.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function speak(line) {
 console.log(`The ${this.type} rabbit says '${line}'`);
}
let whiteRabbit = {type: "white", speak};
let hungryRabbit = {type: "hungry", speak};

whiteRabbit.speak("Oh my ears and whiskers, " +
                 "how late it's getting!");
// → The white rabbit says 'Oh my ears and whiskers, how
//   late it's getting!'
hungryRabbit.speak("I could use a carrot right now.");
// → The hungry rabbit says 'I could use a carrot right now.'</code></pre></div></div></div></section><section id="_a_jde_to_i_naopak"><h2>A jde to i naopak</h2><div class="slide-content"><div class="paragraph"><p>Vě většině programovacích jazyků se metody volají přes <code>.</code>: <code>rabbit.speak("I&#8217;m alive.");</code></p></div>
<div class="ulist"><ul><li><p>JavaScript umožňuje volání přes funkci <code>call</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">speak.call(hungryRabbit, "Burp!");
// → The hungry rabbit says 'Burp!'</code></pre></div></div></div></section><section id="_arrow_funkce_a_objekty"><h2><em>Arrow funkce</em> a objekty</h2><div class="slide-content"><div class="paragraph"><p>Tady je jedna z výjimek <em>arrow funkcí</em>, které <strong>nemají</strong> klíčové slovo <code>this</code>.</p></div>
<div class="ulist"><ul><li><p>Ale vidí <code>this</code> nadřazené funkce, lze tedy napsat</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function normalize() {
 console.log(this.coords.map(n =&gt; n / this.length));
}
normalize.call({coords: [0, 2, 3], length: 5});
// → [0, 0.4, 0.6]</code></pre></div></div></div></section></section>
<section><section id="_prototypy"><h2>Prototypy</h2><div class="slide-content"><div class="paragraph"><p>Každý objekt musí mít objekt ze kterého vychází, těm se říká <em>prototypy</em>.</p></div><div class="ulist"><ul><li><p>JavaScript existuje jeden základní prototyp, ze kterého vznikají všechny objekty, když není řešeno jinak.</p></li><li><p>Takto je možné že každý objekt má metodu <code>toString()</code></p></li></ul></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let empty = {};
console.log(empty.toString);
// → function toString(){…}
console.log(empty.toString());
// → [object Object]</code></pre></div></div></div></section><section id="_definice_vlastního_prototypu"><h2>Definice vlastního prototypu</h2><div class="slide-content"><div class="paragraph"><p>Vytvoření prototypu je snadná vec, může to být jakýkoliv objekt</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let protoRabbit = {
 speak(line) {
   console.log(`The ${this.type} rabbit says '${line}'`);
 }
};</code></pre></div></div></div></section><section id="_vytvoření_objektu"><h2>Vytvoření objektu</h2><div class="slide-content"><div class="paragraph"><p>Pro vytvoření pak použijeme metodu <code>Object.create</code>.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let killerRabbit = Object.create(protoRabbit);
killerRabbit.type = "killer";
killerRabbit.speak("SKREEEE!");
// → The killer rabbit says 'SKREEEE!'</code></pre></div></div></div></section><section id="_funkce_jako_constructor"><h2>Funkce jako constructor</h2><div class="slide-content"><div class="paragraph"><p>Pokud potřebuje vytvářet více objektů se stejným interfacem, můžeme si k tomu patřičnou funkci</p></div>
<div class="ulist"><ul><li><p>Tato funkce nám zajistí že všechny objekty "zajíci" budou mít ty, správné funkce a vlastnosti.</p></li><li><p>Hezké na tomto přístupu je, že je velmi přímočarý</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function makeRabbit(type) {
 let rabbit = Object.create(protoRabbit);
 rabbit.type = type;
 return rabbit;
}</code></pre></div></div></div></section><section id="_funkce_jako_třída"><h2>Funkce jako třída</h2><div class="slide-content"><div class="paragraph"><p>JAvascript umožňuje použít funkci jako předpis pro třídu.</p></div>
<div class="ulist"><ul><li><p>Tento způsob je bližší ostatním jazykům.</p></li><li><p>Nový objekt se pak vytváří pomocí klíčového slova <code>new</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">function Rabbit(type) {
 this.type = type;
}

Rabbit.prototype.speak = function(line) {
 console.log(`The ${this.type} rabbit says '${line}'`);
};

let weirdRabbit = new Rabbit("weird");</code></pre></div></div>
<div class="paragraph"><p>Díky tomu, že se po definici funkce ještě musíme pracovat s <code>prototypem</code> je výsledek trochu nepřehledný.</p></div></div></section></section>
<section><section id="_klíčové_slovo_class"><h2>Klíčové slovo <code>class</code></h2><div class="slide-content"><div class="paragraph"><p>Od roku 2015 se v JavaScriptu objevilo klíčové slovo <code>class</code></p></div><div class="ulist"><ul><li><p>Tím se JavaScript přiblížil Jave a dalším objektovým jazykům.</p></li><li><p>Díky tomu je syntakce vytváření objektů jasnější a čitelnější.</p></li></ul></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">class Rabbit {
 constructor(type) {
   this.type = type;
 }
 speak(line) {
   console.log(`The ${this.type} rabbit says '${line}'`);
 }
}

let killerRabbit = new Rabbit("killer");
let blackRabbit = new Rabbit("black");</code></pre></div></div></div></section><section id="_class_ve_výrazu"><h2><code>class</code> ve výrazu</h2><div class="slide-content"><div class="paragraph"><p>Aby byla zachována kontinuita, lze <code>class</code> stejně jako <code>function</code> použít i ve výrazu</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let object = new class {
 getWord() {
   return "hello";
 }
};

console.log(object.getWord());
// → hello</code></pre></div></div></div></section><section id="_getters_and_setters"><h2>getters and setters</h2><div class="slide-content"><div class="paragraph"><p>Také můžeme lépe zapouzdřit objekt a definovat na něm vlastnosti:</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">class Temperature {
 constructor(celsius) {
   this.celsius = celsius;
 }
 get fahrenheit() {
   return this.celsius * 1.8 + 32;
 }
 set fahrenheit(value) {
   this.celsius = (value - 32) / 1.8;
 }
}</code></pre></div></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let temp = new Temperature(22);
console.log(temp.fahrenheit);
// → 71.6
temp.fahrenheit = 86;
console.log(temp.celsius);
// → 30</code></pre></div></div></div></section><section id="_klíčové_slovo_static"><h2>klíčové slovo <code>static</code></h2><div class="slide-content"><div class="paragraph"><p>Také můžeme přiřadit metodu třídě a ne objektu</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">class Temperature {
 constructor(celsius) {
   this.celsius = celsius;
 }
  static fromFahrenheit(value) {
   return new Temperature((value - 32) / 1.8);
 }

}

Temperature.fromFahrenheit(100)</code></pre></div></div></div></section><section id="_dědičnost"><h2>Dědičnost</h2><div class="slide-content"><div class="paragraph"><p>Díky klíčovému slovu <code>extends</code> můžeme nahradit <em>prototypovou</em> dědičnost.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">class WildRabit extends Rabit {
 // TODO code here
}</code></pre></div></div></div></section><section id="_procházení_objektů"><h2>Procházení objektů</h2><div class="slide-content"><div class="paragraph"><p>Na objektech je také možné implementovat takzavaný iterátor</p></div>
<div class="ulist"><ul><li><p>Takto vybavené objekty je pak možné použít ve <em>for-each</em> smyčce</p></li><li><p>NEbo na nich volat metodu <code>next</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let okIterator = "OK"[Symbol.iterator]();
console.log(okIterator.next());
// → {value: "O", done: false}
console.log(okIterator.next());
// → {value: "K", done: false}
console.log(okIterator.next());
// → {value: undefined, done: true}</code></pre></div></div></div></section></section>
<section><section id="_summary"><h2>Summary</h2><div class="slide-content"><div class="paragraph"><p>Objekty tedy dělají více než jen drží své vlastní vlastnosti.</p></div><div class="ulist"><ul><li><p>Mají prototypy, což jsou další objekty.</p></li><li><p>Budou se chovat, jako by měli vlastnosti, které nemají, pokud tuto vlastnost má jejich prototyp.</p></li><li><p>Jednoduché objekty mají jako prototyp Object.prototype.</p></li></ul></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Konstruktory, což jsou funkce, jejichž názvy obvykle začínají velkým písmenem, lze s novým operátorem použít k vytváření nových objektů.</p></div>
<div class="ulist"><ul><li><p>Prototypem nového objektu bude objekt nalezený ve vlastnosti prototypu konstruktora.</p></li><li><p>Toho můžete dobře využít vložením vlastností, které všechny hodnoty daného typu sdílejí do svého prototypu.</p></li><li><p>Existuje také <code>class</code>, která poskytuje jasný způsob definování konstruktoru a jeho prototypu.</p></li></ul></div></div></section><section><div class="slide-content"><div class="paragraph"><p>U objektů můžeme definovat poměrně dost věcí:
* Již dříve zmíněné vlastnosti a metody
* gettry a settry, pro řízení přístupu k vlastnostem objektu.
* Statické metody jsou metody uložené v konstruktoru třídy, nikoli v jeho prototypu.
* Iterátor který slouží k procházení vlastností/stavu objektu</p></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Při psaní objektů se snažte vytvořit jednoduché a jasné rozhraní, pomocí které s objektem komunikuje.</p></div>
<div class="ulist"><ul><li><p>Zbývající detaily, které tvoří váš objekt, by měly být schované.</p></li><li><p>Pokud jedno rozhraní imemementuje více objektů, říká se tomu <em>polymorfismus</em>.</p></li><li><p>Pokud se třídy liší v detaily, můžeme společné části vytáhnout do společného předka.</p></li></ul></div></div></section></section>
<section><section id="_cvičení"><h2>Cvičení</h2></section><section id="_třída_vektor"><h2>Třída vektor</h2><div class="slide-content"><div class="paragraph"><p>Vytvořte třídu vektor pro souřadnice ve 2D prostoru s vlastnostmi <code>x</code> a <code>y</code>.</p></div>
<div class="ulist"><ul><li><p>Na této třídě definujte metody <code>plus</code> a <code>minus</code></p></li><li><p>Naimplementujte vlastnost <code>length</code> který vrátí velikost vektoru</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(new Vec(1, 2).plus(new Vec(2, 3)));
// → Vec{x: 3, y: 5}
console.log(new Vec(1, 2).minus(new Vec(2, 3)));
// → Vec{x: -1, y: -1}
console.log(new Vec(3, 4).length);
// → 5</code></pre></div></div></div></section><section id="_vytvořte_třídu_halda"><h2>Vytvořte třídu <code>Halda</code></h2><div class="slide-content"><div class="paragraph"><p>Halda je struktura chovající se podobně jako množina.</p></div>
<div class="ulist"><ul><li><p>Každý prvek může být v Haldě jen jednou.</p></li><li><p>Me metody</p><div class="ulist"><ul><li><p><code>add</code> na přidání prvku do haldy</p></li><li><p><code>delete</code> na odebrání prvku</p></li><li><p><code>has</code>, která testuje zda prvek v Haldě je.</p></li><li><p>statická metoda <code>from</code>, která vytvoří haldu ze seznamu</p></li></ul></div></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let halda = Halda.from([10, 20]);
console.log(group.has(10));
// → true
console.log(group.has(30));
// → false
group.add(10);
group.delete(10);
console.log(group.has(10));
// → false</code></pre></div></div></div></section></section></div></div><script src="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'bottom-right',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: false,
  // Control which views the slide number displays on
  showSlideNumber: 'all',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: false,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Vertical centering of slides
  center: false,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: false,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: null,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 0,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 3,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 1250,
  height: 700,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/zoom-js/zoom.js', async: true },
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/notes/notes.js', async: true }
  ],

  

});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(1250, 700)
});</script><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/lib/css/monokai.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>

<script>

/* highlightjs-line-numbers.js 2.6.0 | (C) 2018 Yauheni Pakala | MIT License | github.com/wcoder/highlightjs-line-numbers.js */
/* Edited by Hakim for reveal.js; removed async timeout */
!function(n,e){"use strict";function t(){var n=e.createElement("style");n.type="text/css",n.innerHTML=g(".{0}{border-collapse:collapse}.{0} td{padding:0}.{1}:before{content:attr({2})}",[v,L,b]),e.getElementsByTagName("head")[0].appendChild(n)}function r(t){"interactive"===e.readyState||"complete"===e.readyState?i(t):n.addEventListener("DOMContentLoaded",function(){i(t)})}function i(t){try{var r=e.querySelectorAll("code.hljs,code.nohighlight");for(var i in r)r.hasOwnProperty(i)&&l(r[i],t)}catch(o){n.console.error("LineNumbers error: ",o)}}function l(n,e){"object"==typeof n&&f(function(){n.innerHTML=s(n,e)})}function o(n,e){if("string"==typeof n){var t=document.createElement("code");return t.innerHTML=n,s(t,e)}}function s(n,e){e=e||{singleLine:!1};var t=e.singleLine?0:1;return c(n),a(n.innerHTML,t)}function a(n,e){var t=u(n);if(""===t[t.length-1].trim()&&t.pop(),t.length>e){for(var r="",i=0,l=t.length;i<l;i++)r+=g('<tr><td class="{0}"><div class="{1} {2}" {3}="{5}"></div></td><td class="{4}"><div class="{1}">{6}</div></td></tr>',[j,m,L,b,p,i+1,t[i].length>0?t[i]:" "]);return g('<table class="{0}">{1}</table>',[v,r])}return n}function c(n){var e=n.childNodes;for(var t in e)if(e.hasOwnProperty(t)){var r=e[t];h(r.textContent)>0&&(r.childNodes.length>0?c(r):d(r.parentNode))}}function d(n){var e=n.className;if(/hljs-/.test(e)){for(var t=u(n.innerHTML),r=0,i="";r<t.length;r++){var l=t[r].length>0?t[r]:" ";i+=g('<span class="{0}">{1}</span>\n',[e,l])}n.innerHTML=i.trim()}}function u(n){return 0===n.length?[]:n.split(y)}function h(n){return(n.trim().match(y)||[]).length}function f(e){e()}function g(n,e){return n.replace(/{(\d+)}/g,function(n,t){return e[t]?e[t]:n})}var v="hljs-ln",m="hljs-ln-line",p="hljs-ln-code",j="hljs-ln-numbers",L="hljs-ln-n",b="data-line-number",y=/\r\n|\r|\n/g;n.hljs?(n.hljs.initLineNumbersOnLoad=r,n.hljs.lineNumbersBlock=l,n.hljs.lineNumbersValue=o,t()):n.console.error("highlight.js not detected!")}(window,document);

/**
 * This reveal.js plugin is wrapper around the highlight.js
 * syntax highlighting library.
 */
(function( root, factory ) {
  if (typeof define === 'function' && define.amd) {
    root.RevealHighlight = factory();
  } else if( typeof exports === 'object' ) {
    module.exports = factory();
  } else {
    // Browser globals (root is window)
    root.RevealHighlight = factory();
  }
}( this, function() {

  // Function to perform a better "data-trim" on code snippets
  // Will slice an indentation amount on each line of the snippet (amount based on the line having the lowest indentation length)
  function betterTrim(snippetEl) {
    // Helper functions
    function trimLeft(val) {
      // Adapted from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/Trim#Polyfill
      return val.replace(/^[\s\uFEFF\xA0]+/g, '');
    }
    function trimLineBreaks(input) {
      var lines = input.split('\n');

      // Trim line-breaks from the beginning
      for (var i = 0; i < lines.length; i++) {
        if (lines[i].trim() === '') {
          lines.splice(i--, 1);
        } else break;
      }

      // Trim line-breaks from the end
      for (var i = lines.length-1; i >= 0; i--) {
        if (lines[i].trim() === '') {
          lines.splice(i, 1);
        } else break;
      }

      return lines.join('\n');
    }

    // Main function for betterTrim()
    return (function(snippetEl) {
      var content = trimLineBreaks(snippetEl.innerHTML);
      var lines = content.split('\n');
      // Calculate the minimum amount to remove on each line start of the snippet (can be 0)
      var pad = lines.reduce(function(acc, line) {
        if (line.length > 0 && trimLeft(line).length > 0 && acc > line.length - trimLeft(line).length) {
          return line.length - trimLeft(line).length;
        }
        return acc;
      }, Number.POSITIVE_INFINITY);
      // Slice each line with this amount
      return lines.map(function(line, index) {
        return line.slice(pad);
      })
        .join('\n');
    })(snippetEl);
  }

  var RevealHighlight = {

    HIGHLIGHT_STEP_DELIMITER: '|',
    HIGHLIGHT_LINE_DELIMITER: ',',
    HIGHLIGHT_LINE_RANGE_DELIMITER: '-',

    init: function() {

      // Read the plugin config options and provide fallbacks
      var config = Reveal.getConfig().highlight || {};
      config.highlightOnLoad = typeof config.highlightOnLoad === 'boolean' ? config.highlightOnLoad : true;
      config.escapeHTML = typeof config.escapeHTML === 'boolean' ? config.escapeHTML : true;

      [].slice.call( document.querySelectorAll( '.reveal pre code' ) ).forEach( function( block ) {

        // Trim whitespace if the "data-trim" attribute is present
        if( block.hasAttribute( 'data-trim' ) && typeof block.innerHTML.trim === 'function' ) {
          block.innerHTML = betterTrim( block );
        }

        // Escape HTML tags unless the "data-noescape" attrbute is present
        if( config.escapeHTML && !block.hasAttribute( 'data-noescape' )) {
          block.innerHTML = block.innerHTML.replace( /</g,"&lt;").replace(/>/g, '&gt;' );
        }

        // Re-highlight when focus is lost (for contenteditable code)
        block.addEventListener( 'focusout', function( event ) {
          hljs.highlightBlock( event.currentTarget );
        }, false );

        if( config.highlightOnLoad ) {
          RevealHighlight.highlightBlock( block );
        }
      } );

    },

    /**
     * Highlights a code block. If the <code> node has the
     * 'data-line-numbers' attribute we also generate slide
     * numbers.
     *
     * If the block contains multiple line highlight steps,
     * we clone the block and create a fragment for each step.
     */
    highlightBlock: function( block ) {

      hljs.highlightBlock( block );

      // Don't generate line numbers for empty code blocks
      if( block.innerHTML.trim().length === 0 ) return;

      if( block.hasAttribute( 'data-line-numbers' ) ) {
        hljs.lineNumbersBlock( block, { singleLine: true } );

        // If there is at least one highlight step, generate
        // fragments
        var highlightSteps = RevealHighlight.deserializeHighlightSteps( block.getAttribute( 'data-line-numbers' ) );
        if( highlightSteps.length > 1 ) {

          // If the original code block has a fragment-index,
          // each clone should follow in an incremental sequence
          var fragmentIndex = parseInt( block.getAttribute( 'data-fragment-index' ), 10 );
          if( typeof fragmentIndex !== 'number' || isNaN( fragmentIndex ) ) {
            fragmentIndex = null;
          }

          // Generate fragments for all steps except the original block
          highlightSteps.slice(1).forEach( function( highlight ) {

            var fragmentBlock = block.cloneNode( true );
            fragmentBlock.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlight ] ) );
            fragmentBlock.classList.add( 'fragment' );
            block.parentNode.appendChild( fragmentBlock );
            RevealHighlight.highlightLines( fragmentBlock );

            if( typeof fragmentIndex === 'number' ) {
              fragmentBlock.setAttribute( 'data-fragment-index', fragmentIndex );
              fragmentIndex += 1;
            }
            else {
              fragmentBlock.removeAttribute( 'data-fragment-index' );
            }

          } );

          block.removeAttribute( 'data-fragment-index' )
          block.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlightSteps[0] ] ) );

        }

        RevealHighlight.highlightLines( block );

      }

    },

    /**
     * Visually emphasize specific lines within a code block.
     * This only works on blocks with line numbering turned on.
     *
     * @param {HTMLElement} block a <code> block
     * @param {String} [linesToHighlight] The lines that should be
     * highlighted in this format:
     * "1" 		= highlights line 1
     * "2,5"	= highlights lines 2 & 5
     * "2,5-7"	= highlights lines 2, 5, 6 & 7
     */
    highlightLines: function( block, linesToHighlight ) {

      var highlightSteps = RevealHighlight.deserializeHighlightSteps( linesToHighlight || block.getAttribute( 'data-line-numbers' ) );

      if( highlightSteps.length ) {

        highlightSteps[0].forEach( function( highlight ) {

          var elementsToHighlight = [];

          // Highlight a range
          if( typeof highlight.end === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child(n+'+highlight.start+'):nth-child(-n+'+highlight.end+')' ) );
          }
          // Highlight a single line
          else if( typeof highlight.start === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child('+highlight.start+')' ) );
          }

          if( elementsToHighlight.length ) {
            elementsToHighlight.forEach( function( lineElement ) {
              lineElement.classList.add( 'highlight-line' );
            } );

            block.classList.add( 'has-highlights' );
          }

        } );

      }

    },

    /**
     * Parses and formats a user-defined string of line
     * numbers to highlight.
     *
     * @example
     * RevealHighlight.deserializeHighlightSteps( '1,2|3,5-10' )
     * // [
     * //   [ { start: 1 }, { start: 2 } ],
     * //   [ { start: 3 }, { start: 5, end: 10 } ]
     * // ]
     */
    deserializeHighlightSteps: function( highlightSteps ) {

      // Remove whitespace
      highlightSteps = highlightSteps.replace( /\s/g, '' );

      // Divide up our line number groups
      highlightSteps = highlightSteps.split( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

      return highlightSteps.map( function( highlights ) {

        return highlights.split( RevealHighlight.HIGHLIGHT_LINE_DELIMITER ).map( function( highlight ) {

          // Parse valid line numbers
          if( /^[\d-]+$/.test( highlight ) ) {

            highlight = highlight.split( RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER );

            var lineStart = parseInt( highlight[0], 10 ),
              lineEnd = parseInt( highlight[1], 10 );

            if( isNaN( lineEnd ) ) {
              return {
                start: lineStart
              };
            }
            else {
              return {
                start: lineStart,
                end: lineEnd
              };
            }

          }
          // If no line numbers are provided, no code will be highlighted
          else {

            return {};

          }

        } );

      } );

    },

    /**
     * Serializes parsed line number data into a string so
     * that we can store it in the DOM.
     */
    serializeHighlightSteps: function( highlightSteps ) {

      return highlightSteps.map( function( highlights ) {

        return highlights.map( function( highlight ) {

          // Line range
          if( typeof highlight.end === 'number' ) {
            return highlight.start + RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER + highlight.end;
          }
          // Single line
          else if( typeof highlight.start === 'number' ) {
            return highlight.start;
          }
          // All lines
          else {
            return '';
          }

        } ).join( RevealHighlight.HIGHLIGHT_LINE_DELIMITER );

      } ).join( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

    }

  }

  Reveal.registerPlugin( 'highlight', RevealHighlight );

  return RevealHighlight;

}));
        
hljs.initHighlightingOnLoad();
</script></body></html>